# Enablde tests
%bcond_with check

# Build -python subpackage
%bcond_with python

# Build -java subpackage
%ifarch %{ix86} %{arm} x86_64 aarch64
%bcond_with java
%else
%bcond_with java
%endif

# Version
# Check sub pkg versions from version.json
%define uversion	21.12
%define protocver	3.%{uversion}
%define protobufver     3.%{uversion}
%define protobufjver	3.%{uversion}
# Python uses different major
%define protobufpver    4.%{uversion}

# Major
%define major           32

# Library names
%define libname         %mklibname %{name} %{major}
%define liblite         %mklibname %{name}-lite %{major}
%define libcompiler     %mklibname protoc %{major}
%define develname       %mklibname %{name} -d
%define staticdevelname %mklibname %{name} -d -s

#define rcver rc2

Summary:        Protocol Buffers - Google's data interchange format
Name:           protobuf
Version:        %{uversion}
Release:        %mkrel 2
License:        BSD
Group:          Development/Other
URL:            https://github.com/protocolbuffers/protobuf
Source0:        https://github.com/protocolbuffers/protobuf/archive/v%{version}%{?rcver}/%{name}-%{version}%{?rcver}-all.tar.gz
Source1:        ftdetect-proto.vim
# Backported from upstream
Patch1:         0001-Adding-full-build-to-32-bit-tests-10589.patch
# Backport upstream commit da973aff2adab60a9e516d3202c111dbdde1a50f:
#   Fix build with Python 3.11
#
#   The PyFrameObject structure members have been removed from the public C API.
Patch4:         0001-Fix-build-with-Python-3.11.patch
Patch5:         0002-restore-pypy-support-broken-when-adding-3.11-support.patch
#
# Originally from Gentoo:
Patch101:       protobuf-3.19.1-system_libraries.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=2051202
# java.lang.ClassLoader.defineClass(java.lang.String,byte[],int,int,java.security.ProtectionDomain)
# throws java.lang.ClassFormatError accessible: module java.base does not "opens java.lang" to unnamed module @12d5624a
#       at com.google.protobuf.ServiceTest.testGetPrototype(ServiceTest.java:107)
Patch103:       protobuf-3.19.4-jre17-add-opens.patch
BuildRequires:  automake
BuildRequires:  autoconf
BuildRequires:  libtool
BuildRequires:  pkgconfig
BuildRequires:  pkgconfig(zlib)
BuildRequires:  pkgconfig(gtest)

%if ! %{with java}
Obsoletes:	protobuf-bom < %{version}-%{release}
Obsoletes:	protobuf-java < %{version}-%{release}
Obsoletes:	protobuf-java-util < %{version}-%{release}
Obsoletes:	protobuf-javadoc < %{version}-%{release}
Obsoletes:	protobuf-javalite < %{version}-%{release}
Obsoletes:	protobuf-parent < %{version}-%{release}
%endif

%description
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

Protocol buffers are a flexible, efficient, automated mechanism for
serializing structured data – think XML, but smaller, faster, and
simpler. You define how you want your data to be structured once, then
you can use special generated source code to easily write and read
your structured data to and from a variety of data streams and using a
variety of languages. You can even update your data structure without
breaking deployed programs that are compiled against the "old" format.

%package -n     %{libname}
Summary:        Runtime library for %{name}
Group:          System/Libraries
Version:        %{protobufver}
Obsoletes:      %{_lib}protobuf6 < %{version}-%{release}

%description -n %{libname}
Protocol Buffers are a way of encoding structured data in an efficient
yet extensible format. Google uses Protocol Buffers for almost all of
its internal RPC protocols and file formats.

Protocol buffers are a flexible, efficient, automated mechanism for
serializing structured data - think XML, but smaller, faster, and
simpler. You define how you want your data to be structured once, then
you can use special generated source code to easily write and read
your structured data to and from a variety of data streams and using a
variety of languages. You can even update your data structure without
breaking deployed programs that are compiled against the "old" format.

This package contains the shared %{name} library.

%package -n     %{liblite}
Summary:        Protocol Buffers lite version
Group:          System/Libraries
Version:        %{protobufver}

%description -n %{liblite}
This package contains a compiled with "optimize_for = LITE_RUNTIME"
version of Google's Protocol Buffers library.

The "optimize_for = LITE_RUNTIME" option causes the compiler to
generate code which only depends libprotobuf-lite, which is much
smaller than libprotobuf but lacks descriptors, reflection, and some
other features.

%package        compiler
Summary:        Protocol Buffers compiler
Group:          Development/Other
Version:        %{protobufver}
Recommends:     %{libname} = %{version}
Recommends:     %{liblite} = %{version}

%description    compiler
This package contains Protocol Buffers compiler for all programming
languages.

%package -n     %{libcompiler}
Summary:        Protocol Buffers compiler shared library
Group:          System/Libraries
Version:        %{protobufver}
Obsoletes:      %{_lib}protoc6 < %{version}-%{release}

%description -n %{libcompiler}
This package contains the Protocol Buffers compiler shared library.

%package -n     %{develname}
Summary:        Protocol Buffers C++ headers and libraries
Group:          Development/Libraries
Version:        %{protobufver}
Requires:       %{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{develname}
This package contains Protocol Buffers compiler for all languages and
C++ headers and libraries.

%package -n     %{staticdevelname}
Summary:        Static development files for %{name}
Group:          Development/Libraries
Version:        %{protobufver}
Requires:       %{develname} = %{version}
Provides:       %{name}-static-devel = %{version}-%{release}

%description -n %{staticdevelname}
This package contains static libraries for Protocol Buffers.

%if %{with python}
%package -n     python3-%{name}
Summary:        Python 3 bindings for Google Protocol Buffers
Group:          Development/Python
Version:        %{protobufpver}
#BuildArch:	noarch
#BuildRequires:	pyproject-rpm-macros
BuildRequires:  pkgconfig(python3)
BuildRequires:  python3-setuptools
BuildRequires:  python3-wheel
%{?python_provide:%python_provide python3-%{name}}

%description -n python3-%{name}
This package contains Python 3 libraries for Google Protocol Buffers.
%endif

%package        vim
Summary:        Vim syntax highlighting for Google Protocol Buffers descriptions
Group:          Development/Other
Version:        %{protobufver}
Requires:       vim-enhanced

%description    vim
This package contains syntax highlighting for Google Protocol Buffers
descriptions in Vim editor.

%if %{with java}
%package java
Summary:        Java Protocol Buffers runtime library
Group:          Development/Java
Version:        %{protobufjver}
BuildArch:      noarch
BuildRequires:  maven-local
BuildRequires:  mvn(com.google.code.gson:gson)
BuildRequires:  mvn(com.google.guava:guava)
BuildRequires:  mvn(com.google.guava:guava-testlib)
BuildRequires:  mvn(com.google.truth:truth)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(org.apache.felix:maven-bundle-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-source-plugin)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.easymock:easymock)
BuildRequires:  mvn(org.mockito:mockito-core)

%description java
This package contains Java Protocol Buffers runtime library.

%package javalite
Summary:        Java Protocol Buffers lite runtime library
Group:          Development/Java
Version:        %{protobufjver}
BuildArch:      noarch

%description javalite
This package contains Java Protocol Buffers lite runtime library.

%package java-util
Summary:        Utilities for Protocol Buffers
Group:          Development/Java
Version:        %{protobufjver}
BuildArch:      noarch

%description java-util
Utilities to work with protos. It contains JSON support
as well as utilities to work with proto3 well-known types.

%package bom
Summary:        Protocol Buffer BOM POM
Group:          Development/Java
Version:        %{protobufjver}
BuildArch:      noarch

%description bom
Protocol Buffer BOM POM.

%package javadoc
Summary:        Javadoc for %{name}-java
Group:          Documentation
Version:        %{protobufjver}
BuildArch:      noarch

%description javadoc
This package contains the API documentation for %{name}-java.

%package parent
Summary:        Protocol Buffer Parent POM
Group:          Development/Java
Version:        %{protobufjver}
BuildArch:      noarch

%description parent
Protocol Buffer Parent POM.

%endif

%prep
%autosetup -p1

find -name \*.cc -o -name \*.h | xargs chmod -x

# https://github.com/protocolbuffers/protobuf/issues/7413
sed -e "/^AC_PROG_CXX_FOR_BUILD$/d" -i configure.ac

# https://github.com/protocolbuffers/protobuf/issues/8082
sed -e "/^TEST_F(IoTest, LargeOutput) {$/,/^}$/d" -i src/google/protobuf/io/zero_copy_stream_unittest.cc

# https://github.com/protocolbuffers/protobuf/issues/8459
sed \
	-e "/^TEST(ArenaTest, BlockSizeSmallerThanAllocation) {$/a\\  if (sizeof(void*) == 4) {\n    GTEST_SKIP();\n  }" \
	-e "/^TEST(ArenaTest, SpaceAllocated_and_Used) {$/a\\  if (sizeof(void*) == 4) {\n    GTEST_SKIP();\n  }" \
	-i src/google/protobuf/arena_unittest.cc

# https://github.com/protocolbuffers/protobuf/issues/8460
sed -e "/^TEST(AnyTest, TestPackFromSerializationExceedsSizeLimit) {$/a\\  if (sizeof(void*) == 4) {\n    GTEST_SKIP();\n  }" -i src/google/protobuf/any_test.cc

%if %{with java}
%pom_remove_dep com.google.errorprone:error_prone_annotations java/util/pom.xml
%pom_remove_dep com.google.j2objc:j2objc-annotations java/util/pom.xml

# Remove unnecessary animal sniffer
%pom_remove_plugin org.codehaus.mojo:animal-sniffer-maven-plugin java/pom.xml
%pom_remove_plugin org.codehaus.mojo:animal-sniffer-maven-plugin java/util/pom.xml

# Remove annotation libraries we don't have
annotations=$(
    find -name '*.java' |
      xargs grep -h -e '^import com\.google\.errorprone\.annotation' \
                    -e '^import com\.google\.j2objc\.annotations' |
      sort -u | sed 's/.*\.\([^.]*\);/\1/' | paste -sd\|
)
find -name '*.java' | xargs sed -ri \
    "s/^import .*\.($annotations);//;s/@($annotations)"'\>\s*(\((("[^"]*")|([^)]*))\))?//g'

# Make OSGi dependency on sun.misc package optional
%pom_xpath_inject "pom:configuration/pom:instructions" "<Import-Package>sun.misc;resolution:=optional,*</Import-Package>" java/core

# Backward compatibility symlink
%mvn_file :protobuf-java:jar: %{name}/%{name}-java %{name}

# This test is incredibly slow on arm
# https://github.com/google/protobuf/issues/2389
%ifarch %{arm} s390x
mv java/core/src/test/java/com/google/protobuf/IsValidUtf8Test.java \
   java/core/src/test/java/com/google/protobuf/IsValidUtf8Test.java.slow
mv java/core/src/test/java/com/google/protobuf/DecodeUtf8Test.java \
   java/core/src/test/java/com/google/protobuf/DecodeUtf8Test.java.slow
%endif
%endif

rm -f src/solaris/libstdc++.la

iconv -f iso8859-1 -t utf-8 CONTRIBUTORS.txt > CONTRIBUTORS.txt.utf8
mv CONTRIBUTORS.txt.utf8 CONTRIBUTORS.txt

%build
# -Wno-error=type-limits:
#     https://bugzilla.redhat.com/show_bug.cgi?id=1838470
#     https://github.com/protocolbuffers/protobuf/issues/7514
#     https://gcc.gnu.org/bugzilla/show_bug.cgi?id=95148
#  (also set in %%check)
export CXXFLAGS="%{build_cxxflags} -Wno-error=type-limits"

./autogen.sh
%configure2_5x
%make_build

%if %{with python}
pushd python
#%%pyproject_wheel
LD_LIBRARY_PATH=../src/.libs/libprotobuf.so \
%py3_build -- --cpp_implementation
popd
%endif

%if %{with java}
%ifarch %ix86 s390x %{arm}
export MAVEN_OPTS=-Xmx1024m
%endif
%pom_disable_module kotlin java/pom.xml
%pom_disable_module kotlin-lite java/pom.xml
%mvn_build -s -- -f java/pom.xml
%endif

%install
%make_install STRIPBINARIES=no CPPROG="cp -p"

%if %{with python}
pushd python
#%%pyproject_install
#%%pyproject_save_files google
%py3_install -- --cpp_implementation
popd
%endif

install -p -m 644 -D %{SOURCE1} %{buildroot}%{_datadir}/vim/vimfiles/ftdetect/proto.vim
install -p -m 644 -D editors/proto.vim %{buildroot}%{_datadir}/vim/vimfiles/syntax/proto.vim

rm -rf %buildroot/%{_libdir}/*.la

%if %{with java}
%mvn_install
%endif

%files
%license LICENSE
%doc README.md

%files -n %{libname}
%doc CHANGES.txt CONTRIBUTORS.txt README.md
%license LICENSE
%{_libdir}/lib%{name}.so.%{major}{,.*}

%files -n %{liblite}
%{_libdir}/lib%{name}-lite.so.%{major}{,.*}

%files compiler
%{_bindir}/protoc

%files -n %{libcompiler}
%{_libdir}/libprotoc.so.%{major}{,.*}

%files -n %{develname}
%doc examples/add_person.cc examples/addressbook.proto
%doc examples/list_people.cc examples/Makefile examples/README.md
%dir %{_includedir}/google/
%{_includedir}/google/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}-lite.so
%{_libdir}/libprotoc.so
%{_libdir}/pkgconfig/%{name}.pc
%{_libdir}/pkgconfig/%{name}-lite.pc

%files -n %{staticdevelname}
%{_libdir}/lib%{name}.a
%{_libdir}/lib%{name}-lite.a
%{_libdir}/libprotoc.a

%if %{with python}
%files -n python3-%{name}
%doc python/README.md
%doc examples/add_person.py examples/list_people.py examples/addressbook.proto
%{python3_sitearch}/protobuf-%{protobufpver}%{?rcver}-py%{python3_version}-nspkg.pth
%{python3_sitearch}/protobuf-%{protobufpver}%{?rcver}-py%{python3_version}.egg-info/
%{python3_sitearch}/google/protobuf/
%endif

%files vim
%{_datadir}/vim/vimfiles/ftdetect/proto.vim
%{_datadir}/vim/vimfiles/syntax/proto.vim

%if %{with java}
%files java -f .mfiles-protobuf-java

%files java-util -f .mfiles-protobuf-java-util

%files javadoc -f .mfiles-javadoc

%files parent -f .mfiles-protobuf-parent

%files bom -f .mfiles-protobuf-bom

%files javalite -f .mfiles-protobuf-javalite
%endif


%changelog
* Fri Nov 08 2024 tex - 21.12-2pclos2024
- rebuild against updates

* Tue Oct 22 2024 tex - 21.12-1pclos2024
- new
